Attribute VB_Name = "EventsModule"
Option Explicit

Public Const BossScore = 500
Public Const SmallScore = 50
Public Const ArmyScore = 100
Public Const MArmyScore = 250
Public Const LorryScore = 150
Public Const UFOScore = 1000

Public WEx As Integer

Public Sub CallBoss(Optional BossHP As Integer = 50)
Dim BossMoveDir As Boolean
Dim CanFire As Boolean
Dim WhichBossBomb As Integer
    Randomize Timer
    CanFire = True
    WEx = 1
    BossMoveDir = True
    WhichBossBomb = 0
    Boss.x = 100
    Boss.y = -Boss.Height
    For Ret = 0 To 4
        BossBomb(Ret).x = -BossBomb(Ret).Width
    Next Ret
    Do
        Tick = GetTickCount
        DoEvents
        frmMain.War.Cls
        
        frmMain.ScrollBackGround 5
        
        If Boss.y < 100 Then Boss.y = Boss.y + 1
        If Boss.y >= 100 Then
            If BossMoveDir = True Then
                Boss.x = Boss.x + 1
                If Boss.x >= 300 Then BossMoveDir = False
            Else
                Boss.x = Boss.x - 1
                If Boss.x <= 100 Then BossMoveDir = True
            End If
        End If
        
        If CanFire = True Then
            BossBomb(WhichBossBomb).x = Boss.x + Int(Rnd * 72 + 1)
            BossBomb(WhichBossBomb).y = Boss.y + Boss.Height
            WhichBossBomb = WhichBossBomb + 1
            If WhichBossBomb >= 5 Then
                WhichBossBomb = 0
                CanFire = False
            End If
        End If
        
        For Ret = 0 To 4
            BossBomb(Ret).y = BossBomb(Ret).y + 5
            BossBomb(Ret).Paste frmMain.War.hdc
        Next Ret
        
        If BossBomb(4).y > frmMain.War.Height Then CanFire = True
            
        If BossHP > 0 Then Boss.Paste frmMain.War.hdc
        
        frmMain.PlaneControl
        frmMain.BombControl
        
        DisplayScore
        
        For Ret = 0 To 4
            If HitTest(Plane, BossBomb(Ret)) Then
                PlaneHP = False
                BossHP = -1
            End If
        Next Ret
        
        If HitTest(Plane, Boss) Then
            PlaneHP = False
            BossHP = -1
        End If
        
        For Ret = 0 To HowManyBomb
            If HitTest(Bomb(Ret), Boss) Then
                RndPlaySound
                BossHP = BossHP - 1
                Bomb(Ret).x = -Bomb(Ret).Width
            End If
        Next Ret
        
        If PlaneHP = False Then
            PlayEx WEx, Plane
            WEx = WEx + 1
            If WEx >= 10 Then Exit Sub
        End If
        
        If BossHP <= 0 Then
            PlayEx WEx, Boss, True
            WEx = WEx + 1
            If WEx >= 10 Then
                Score = Score + BossScore
                Exit Sub
            End If
        End If
        
        frmMain.War.Refresh
        Do Until GetTickCount - Tick >= DelayTime
        Loop
    Loop
End Sub

Public Sub CallSmall()
Dim SmallHP As Boolean
    Randomize Timer
    SmallHP = True
    Small.x = GetRandomNumber(frmMain.War.ScaleWidth / 3, frmMain.War.ScaleHeight * 2 / 3)
    Small.y = -Small.Height
    WEx = 1
    Do
        Tick = GetTickCount
        DoEvents
        frmMain.War.Cls
        
        frmMain.ScrollBackGround 3
        
        Small.y = Small.y + 5
        
        If SmallHP = True Then Small.Paste frmMain.War.hdc
        
        frmMain.PlaneControl
        frmMain.BombControl
        
        DisplayScore
        
        If HitTest(Plane, Small) Then
            PlaneHP = False
            SmallHP = False
        End If
        
        For Ret = 0 To HowManyBomb
            If HitTest(Bomb(Ret), Small) Then
                SmallHP = False
                Bomb(Ret).x = -Bomb(Ret).Width
            End If
        Next Ret
        
        If PlaneHP = False Then
            PlayEx WEx, Plane
            WEx = WEx + 1
            If WEx >= 10 Then Exit Sub
        End If
        
        If SmallHP = False Then
            PlayEx WEx, Small
            WEx = WEx + 1
            If WEx >= 10 Then
                Score = Score + SmallScore
                Exit Sub
            End If
        End If
        
        If Small.y > frmMain.War.Height Then Exit Sub
        
        frmMain.War.Refresh
        Do Until GetTickCount - Tick >= DelayTime
        Loop
    Loop
End Sub

Public Sub CallMArmy(Optional MArmyHP As Integer = 10)
Dim CanFire As Boolean
Dim WhichMArmyBomb As Integer
    Randomize Timer
    CanFire = True
    WhichMArmyBomb = 0
    MArmy.x = GetRandomNumber(frmMain.War.ScaleWidth / 3, frmMain.War.ScaleHeight * 2 / 3)
    MArmy.y = -MArmy.Height
    For Ret = 0 To 2
        MArmyBomb(Ret).x = -MArmyBomb(Ret).Width
    Next Ret
    WEx = 1
    Do
        Tick = GetTickCount
        DoEvents
        frmMain.War.Cls
        
        frmMain.ScrollBackGround 3
        
        If MArmy.y < 100 Then MArmy.y = MArmy.y + 2
        
        If CanFire = True Then
            MArmyBomb(WhichMArmyBomb).x = MArmy.x + MArmy.Width / 2 - MArmyBomb(WhichMArmyBomb).Width / 2
            MArmyBomb(WhichMArmyBomb).y = MArmy.y + MArmy.Height
            WhichMArmyBomb = WhichMArmyBomb + 1
            If WhichMArmyBomb >= 3 Then
                WhichMArmyBomb = 0
                CanFire = False
            End If
        End If
        
        MArmyBomb(0).x = MArmyBomb(0).x - 5
        MArmyBomb(2).x = MArmyBomb(2).x + 5
        
        For Ret = 0 To 2
            MArmyBomb(Ret).y = MArmyBomb(Ret).y + 5
            MArmyBomb(Ret).Paste frmMain.War.hdc
        Next Ret
        
        If MArmyBomb(2).y > frmMain.War.Height Then CanFire = True
            
        If MArmyHP > 0 Then MArmy.Paste frmMain.War.hdc
        
        frmMain.PlaneControl
        frmMain.BombControl
        
        DisplayScore
        
        For Ret = 0 To 2
            If HitTest(Plane, MArmyBomb(Ret)) Then
                PlaneHP = False
                MArmyHP = -1
            End If
        Next Ret
        
        If HitTest(Plane, MArmy) Then
            PlaneHP = False
            MArmyHP = -1
        End If
        
        For Ret = 0 To HowManyBomb
            If HitTest(Bomb(Ret), MArmy) Then
                RndPlaySound
                MArmyHP = MArmyHP - 1
                Bomb(Ret).x = -Bomb(Ret).Width
            End If
        Next Ret
        
        If PlaneHP = False Then
            PlayEx WEx, Plane
            WEx = WEx + 1
            If WEx >= 10 Then Exit Sub
        End If
        
        If MArmyHP <= 0 Then
            PlayEx WEx, MArmy, True
            WEx = WEx + 1
            If WEx >= 10 Then
                Score = Score + MArmyScore
                Exit Sub
            End If
        End If
        
        frmMain.War.Refresh
        Do Until GetTickCount - Tick >= DelayTime
        Loop
    Loop
End Sub

Public Sub CallUFO(Optional UFOHP As Integer = 100)
Dim CanFire As Boolean
Dim UFOMoveDir As Boolean
Dim BossMoveDir As Boolean
Dim WhichBossBomb As Integer

    Randomize Timer
    CanFire = True
    UFOMoveDir = True
    UFO.x = frmMain.War.Width / 2 - UFO.Width / 2
    UFO.y = frmMain.War.Height
    For Ret = 0 To UFOBombNumber
        UFOBomb(Ret).x = -UFOBomb(Ret).Width
    Next Ret
    WEx = 1
    Randomize Timer
    WhichBossBomb = 0
    For Ret = 0 To 4
        BossBomb(Ret).x = -BossBomb(Ret).Width
    Next Ret
    Do
        Tick = GetTickCount
        DoEvents
        frmMain.War.Cls
        
        frmMain.ScrollBackGround 7
        
        If UFO.y > 100 Then UFO.y = UFO.y - 5
        
        If UFO.y <= 100 Then
            If UFOMoveDir = True Then
                UFO.x = UFO.x + 1
                If UFO.x >= 300 Then UFOMoveDir = False
            Else
                UFO.x = UFO.x - 1
                If UFO.x <= 100 Then UFOMoveDir = True
            End If
        End If
        
        If UFOHP > 0 Then UFO.Paste frmMain.War.hdc

        If CanFire = True Then
            For Ret = 0 To UFOBombNumber
                UFOBomb(Ret).x = (frmMain.War.Width * Ret / UFOBombNumber) - UFOBomb(Ret).Width
                UFOBomb(Ret).y = -UFO.Height
            Next Ret
            BossBomb(WhichBossBomb).x = UFO.x + Int(Rnd * 72 + 1)
            BossBomb(WhichBossBomb).y = UFO.y + UFO.Height
            WhichBossBomb = WhichBossBomb + 1
            If WhichBossBomb >= 5 Then
                WhichBossBomb = 0
                CanFire = False
            End If

        End If
            
        For Ret = 0 To UFOBombNumber
            UFOBomb(Ret).y = UFOBomb(Ret).y + 5
            UFOBomb(Ret).Paste frmMain.War.hdc
            If UFOBomb(Ret).y > frmMain.War.Height Then CanFire = True
        Next Ret
        
        
        frmMain.PlaneControl
        frmMain.BombControl
        
        DisplayScore
        
        For Ret = 0 To 4
            BossBomb(Ret).y = BossBomb(Ret).y + 5
            BossBomb(Ret).Paste frmMain.War.hdc
        Next Ret
        
        For Ret = 0 To 4
            If HitTest(Plane, BossBomb(Ret)) Then
                PlaneHP = False
            End If
        Next Ret
        
        For Ret = 0 To UFOBombNumber
            If HitTest(Plane, UFOBomb(Ret)) Then
                PlaneHP = False
            End If
        Next Ret
        
        If HitTest(Plane, UFO) Then PlaneHP = False
        For Ret = 0 To HowManyBomb
            If HitTest(Bomb(Ret), UFO) Then
                RndPlaySound
                UFOHP = UFOHP - 1
                Bomb(Ret).x = -Bomb(Ret).Width
            End If
        Next Ret
        
        If PlaneHP = False Then
            PlayEx WEx, Plane
            WEx = WEx + 1
            If WEx >= 10 Then
                PlaneTotalHP = 1
                Exit Sub
            End If
        End If
        
        If UFOHP <= 0 Then
            PlayEx WEx, UFO, True
            WEx = WEx + 1
            If WEx >= 10 Then
                Score = Score + UFOScore
                Exit Sub
            End If
        End If
        
        frmMain.War.Refresh
        Do Until GetTickCount - Tick >= DelayTime
        Loop
    Loop
End Sub

Public Sub CallLorry(Optional LorryHP As Integer = 1)
Dim CanFire As Boolean
Dim WhichLorryBomb As Integer
    Randomize Timer
    CanFire = True
    WhichLorryBomb = 0
    Lorry.x = GetRandomNumber(frmMain.War.ScaleWidth / 3, frmMain.War.ScaleHeight * 2 / 3)
    Lorry.y = -Lorry.Height
    For Ret = 0 To 2
        LorryBomb(Ret).x = -LorryBomb(Ret).Width
    Next Ret
    WEx = 1
    Do
        Tick = GetTickCount
        DoEvents
        frmMain.War.Cls
        
        frmMain.ScrollBackGround 3
        
        Lorry.y = Lorry.y + 1
        
        If CanFire = True Then
            LorryBomb(WhichLorryBomb).x = Lorry.x + Lorry.Width / 2 - LorryBomb(WhichLorryBomb).Width / 2
            LorryBomb(WhichLorryBomb).y = Lorry.y + Lorry.Height
            WhichLorryBomb = WhichLorryBomb + 1
            If WhichLorryBomb >= 3 Then
                WhichLorryBomb = 0
                CanFire = False
            End If
        End If
        
        LorryBomb(0).x = LorryBomb(0).x - 2
        LorryBomb(2).x = LorryBomb(2).x + 2
        
        For Ret = 0 To 2
            LorryBomb(Ret).y = LorryBomb(Ret).y + 4
            LorryBomb(Ret).Paste frmMain.War.hdc
        Next Ret
        
        If LorryBomb(2).y > frmMain.War.Height Then CanFire = True
            
        If LorryHP > 0 Then Lorry.Paste frmMain.War.hdc
        
        frmMain.PlaneControl
        frmMain.BombControl
        
        DisplayScore
        
        For Ret = 0 To 2
            If HitTest(Plane, LorryBomb(Ret)) Then
                PlaneHP = False
                LorryHP = -1
            End If
        Next Ret
        
        If HitTest(Plane, Lorry) Then LorryHP = 0
        For Ret = 0 To HowManyBomb
            If HitTest(Bomb(Ret), Lorry) Then
                LorryHP = LorryHP - 1
                Bomb(Ret).x = -Bomb(Ret).Width
            End If
        Next Ret
        
        If PlaneHP = False Then
            PlayEx WEx, Plane
            WEx = WEx + 1
            If WEx >= 10 Then Exit Sub
        End If
        
        If LorryHP <= 0 Then
            PlayEx WEx, Lorry
            WEx = WEx + 1
            If WEx >= 10 Then
                Score = Score + LorryScore
                Exit Sub
            End If
        End If
        
        If Lorry.y >= frmMain.War.Height Then Exit Sub
        
        frmMain.War.Refresh
        Do Until GetTickCount - Tick >= DelayTime
        Loop
    Loop
End Sub

Public Sub CallArmy()
Dim ArmyHP As Boolean
Dim CanFire As Boolean
Dim Direc As Byte
    Randomize Timer
    CanFire = True
    ArmyHP = True
    WEx = 1
    Army.x = GetRandomNumber(frmMain.War.ScaleWidth / 3, frmMain.War.ScaleHeight * 2 / 3)
    Army.y = -Army.Height
    ArmyBomb.x = -ArmyBomb.Width
    ArmyBomb.y = frmMain.War.Height
    Do
        Tick = GetTickCount
        DoEvents
        frmMain.War.Cls
        
        frmMain.ScrollBackGround 3
        
        Army.y = Army.y + 4
        
        If CanFire = True Then
            If Plane.x < Army.x - 50 Then
                Direc = 1
                
            ElseIf Plane.x > Army.x + 50 Then
                Direc = 2
            End If
        End If
        
        If CanFire = True And Army.y > 100 Then
            ArmyBomb.x = Army.x + Army.Width / 2 - ArmyBomb.Width / 2
            ArmyBomb.y = Army.y + Army.Height
            CanFire = False
        End If
        
        Select Case Direc
            Case 1
                ArmyBomb.x = ArmyBomb.x - 2
            Case 2
                ArmyBomb.x = ArmyBomb.x + 2
        End Select
            
        ArmyBomb.y = ArmyBomb.y + 6
        ArmyBomb.Paste frmMain.War.hdc
            
        If ArmyHP = True Then Army.Paste frmMain.War.hdc
        
        frmMain.PlaneControl
        frmMain.BombControl
        
        DisplayScore
        
        If HitTest(Plane, ArmyBomb) Then
            PlaneHP = False
            ArmyHP = False
        End If
        
        If HitTest(Plane, Army) Then
            PlaneHP = False
            ArmyHP = False
        End If
        
        For Ret = 0 To HowManyBomb
            If HitTest(Bomb(Ret), Army) Then
                ArmyHP = False
                Bomb(Ret).x = -Bomb(Ret).Width
            End If
        Next Ret
        
        If PlaneHP = False Then
            PlayEx WEx, Plane
            WEx = WEx + 1
            If WEx >= 10 Then Exit Sub
        End If
        
        If ArmyHP = False Then
            PlayEx WEx, Army
            WEx = WEx + 1
            If WEx >= 10 Then
                Score = Score + ArmyScore
                Exit Sub
            End If
        End If
        If Army.y > frmMain.War.Height Then Exit Sub
        
        frmMain.War.Refresh
        Do Until GetTickCount - Tick >= DelayTime
        Loop
    Loop
End Sub

Public Sub StartPlane()
    PlaneHP = True
    HaveToBomb = False
    Plane.x = frmMain.War.Width / 2 - Plane.Width / 2
    Plane.y = frmMain.War.Height * 4 / 5
    For Ret = 0 To HowManyBomb
        Bomb(Ret).x = -Bomb(Ret).Width
    Next Ret
End Sub

Public Sub CallDelay(ST As Integer, StrS As String)
Dim Scount As Long
Dim W As Long, H As Long
Dim T As Long

    W = frmMain.War.TextWidth(StrS)
    H = frmMain.War.TextHeight(StrS)
    Scount = 0
    T = -W
    Do
        DoEvents
        Tick = GetTickCount
        DoEvents
        frmMain.War.Cls
        frmMain.ScrollBackGround ST
        frmMain.PlaneControl
        If T < frmMain.War.Width / 2 - W / 2 Then
            T = T + 3
        ElseIf T >= frmMain.War.Width / 2 - W / 2 Then
            Exit Sub
        End If
        TextOut frmMain.War.hdc, T, frmMain.War.Height / 2 - H / 2, StrS, Len(StrS)
        frmMain.War.Refresh

        Do Until GetTickCount - Tick >= DelayTime
            If T >= frmMain.War.Width / 2 - W / 2 Then Exit Sub
        Loop
    Loop
End Sub
