Attribute VB_Name = "MainModule"
Option Explicit

Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function ChangeDisplaySettings Lib "user32" Alias "ChangeDisplaySettingsA" (ByVal lpwinmode As Long, ByVal dwflags As Long) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Public Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Public Declare Function GetTickCount Lib "kernel32" () As Long
Public Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (lpString1 As DEVMODE, lpString2 As DEVMODE) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long
Public Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Public Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long

Public Const BombSpeed = 5
Public Const BombFireTick = 250
Public Const CCHDEVICENAME = 32
Public Const CCHFORMNAME = 32
Public Const DelayTime = 15
Public Const DM_BITSPERPEL = &H40000
Public Const DM_PELSHEIGHT = &H100000
Public Const DM_PELSWIDTH = &H80000
Public Const HowManyBomb = 5
Public Const PlaneMoveSpeed = 2
Public Const UFOBombNumber = 8
Public Const MaxPlaneHP = 3

Public Type DEVMODE
        dmDeviceName As String * CCHDEVICENAME
        dmSpecVersion As Integer
        dmDriverVersion As Integer
        dmSize As Integer
        dmDriverExtra As Integer
        dmFields As Long
        dmOrientation As Integer
        dmPaperSize As Integer
        dmPaperLength As Integer
        dmPaperWidth As Integer
        dmScale As Integer
        dmCopies As Integer
        dmDefaultSource As Integer
        dmPrintQuality As Integer
        dmColor As Integer
        dmDuplex As Integer
        dmYResolution As Integer
        dmTTOption As Integer
        dmCollate As Integer
        dmFormName As String * CCHFORMNAME
        dmUnusedPadding As Integer
        dmBitsPerPel As Integer
        dmPelsWidth As Long
        dmPelsHeight As Long
        dmDisplayFlags As Long
        dmDisplayFrequency As Long
End Type

Public Tick                     As Long
Public Ret                      As Integer
Public PlaneHP                  As Boolean
Public HaveChanged              As Boolean
Public OldScreenSetting         As Long
Public HaveToBomb               As Boolean
Public ScrollBackGroundSpeed    As Integer
Public PlaneTotalHP             As Integer
Public Score                    As Long
Public PlayedRound              As Integer

Public Function HitTest(ByVal TP1 As VBExTPCls, ByVal TP2 As VBExTPCls) As Boolean
    If (TP1.x >= TP2.x And TP1.x <= TP2.x + TP2.Width Or TP1.x + TP1.Width >= TP2.x And TP1.x + TP1.Width <= TP2.x + TP2.Width) And (TP1.y >= TP2.y And TP1.y <= TP2.y + TP2.Height Or TP1.y + TP1.Height >= TP2.y And TP1.y + TP1.Height <= TP2.y + TP2.Height) Then HitTest = True
End Function

Public Function IsKeyDown(ExKey As Long) As Boolean
    If GetAsyncKeyState(ExKey) Then
        IsKeyDown = True
    Else
        IsKeyDown = False
    End If
End Function

Public Function GetPathName() As String
Dim ST As String
    ST = App.Path
    If Right(ST, 1) = "\" Then ST = Left(ST, 2)
    GetPathName = ST
End Function

Public Sub Delay(DelayTime As Single)
Dim ST As Single
    ST = GetTickCount
    Do Until GetTickCount - ST > DelayTime
        DoEvents
    Loop
End Sub

Public Sub Main()
Dim ScreenSetting   As DEVMODE
    MakeTP
    PlaneTotalHP = MaxPlaneHP
    Score = 100
    LoadSound
    With ScreenSetting
        .dmSize = Len(ScreenSetting)
        .dmFields = DM_PELSWIDTH Or DM_PELSHEIGHT Or DM_BITSPERPEL
        .dmPelsWidth = 640
        .dmPelsHeight = 480
        .dmBitsPerPel = 16
    End With
    OldScreenSetting = ChangeDisplaySettings(lstrcpy(ScreenSetting, ScreenSetting), 0)
    
    frmMain.Show
    Cursor False
End Sub

Public Sub Cursor(Visible As Boolean)
Dim MouseValue As Long
    If Visible = False Then
        Do Until MouseValue < 0
            MouseValue = ShowCursor(False)
        Loop
    Else
        Do Until MouseValue > 0
            MouseValue = ShowCursor(True)
        Loop
    End If
End Sub

Public Sub EndPlane()
    DTP
    Cursor True
    ChangeDisplaySettings OldScreenSetting, 0
    End
End Sub

Public Function GetRandomNumber(Min As Integer, Max As Integer) As Integer
On Error Resume Next
    If Int(Max) <= Int(Min) Then Err.Raise 32767, , "UȤjW"
    If Min < 0 Then Err.Raise 32767, , "Ups"
    Randomize Timer
    GetRandomNumber = Int(Rnd * (Max - Min + 1) + Min)
End Function
