Attribute VB_Name = "SoundModule"
Option Explicit

Public Const SND_ASYNC = &H1
Public Const SND_MEMORY = &H4
Public Const SND_NOWAIT = &H2000
Public Const SND_NOSTOP = &H10

Public WavExplode   As String
Public WavShoot     As String
Public WavHit       As String

Public Sub PlaySound(SoundName As String)
    Select Case SoundName
        Case "Explode"
            sndPlaySound WavExplode, SND_ASYNC Or SND_MEMORY Or SND_NOWAIT
        Case "Shoot"
            sndPlaySound WavShoot, SND_ASYNC Or SND_MEMORY Or SND_NOSTOP
        Case "Hit"
            sndPlaySound WavHit, SND_ASYNC Or SND_MEMORY Or SND_NOWAIT
    End Select
End Sub

Public Sub LoadSound()
Dim F       As Integer
Dim i       As Integer
Dim MyByte  As Byte
    F = FreeFile
    Open GetPathName & "\Wav\Explode.wav" For Binary As #F
        For i = 1 To 32767
            Get #F, i, MyByte
            If EOF(F) = True Then Exit For
            WavExplode = WavExplode + Chr(MyByte)
        Next
    Close #F
    
    F = FreeFile
    Open GetPathName & "\Wav\Shoot.wav" For Binary As #F
        For i = 1 To 32767
            Get #F, i, MyByte
            If EOF(F) = True Then Exit For
            WavShoot = WavShoot + Chr(MyByte)
        Next
    Close #F
    
    F = FreeFile
    Open GetPathName & "\Wav\Hit.wav" For Binary As #F
        For i = 1 To 32767
            Get #F, i, MyByte
            If EOF(F) = True Then Exit For
            WavHit = WavHit + Chr(MyByte)
        Next
    Close #F
End Sub

Public Sub RndPlaySound()
Dim PlayNum As Integer
    Randomize GetTickCount
    PlayNum = GetRandomNumber(0, 2)
    Select Case PlayNum
        Case 0
            PlaySound "Explode"
        Case 1
            PlaySound "Shoot"
        Case 2
            PlaySound "Hit"
    End Select
End Sub
