VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VBExTPCls"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long

Private Type BITMAP
        bmType As Long
        bmWidth As Long
        bmHeight As Long
        bmWidthBytes As Long
        bmPlanes As Integer
        bmBitsPixel As Integer
        bmBits As Long
End Type

Dim m_DC        As Long
Dim m_BDC       As Long
Dim m_BMP       As Long
Dim m_Width     As Long
Dim m_Height    As Long
Dim TPX         As Long
Dim TPY         As Long

Public Function VBExTP_Load(PictureFile As String, MaskColor As Long)
Dim BM As Picture
Dim PInfo As BITMAP
Dim i As Long, j As Long
    Set BM = LoadPicture(PictureFile)
    m_DC = CreateCompatibleDC(0)
    SelectObject m_DC, BM
    
    GetObject BM, Len(PInfo), PInfo
    m_Width = PInfo.bmWidth
    m_Height = PInfo.bmHeight
    
    m_BDC = CreateCompatibleDC(0)
    m_BMP = CreateCompatibleBitmap(m_BDC, m_Width, m_Height)
    SelectObject m_BDC, m_BMP
    
    For i = 0 To m_Height
        For j = 0 To m_Width
            If GetPixel(m_DC, j, i) <> MaskColor Then
                SetPixel m_BDC, j, i, vbWhite
            Else
                SetPixel m_BDC, j, i, vbBlack
                SetPixel m_DC, j, i, vbBlack
            End If
        Next j
    Next i

    TPX = TPY = 0
End Function

Public Sub Paste(Myhdc As Long)
    BitBlt Myhdc, TPX, TPY, m_Width, m_Height, m_BDC, 0, 0, vbSrcAnd
    BitBlt Myhdc, TPX, TPY, m_Width, m_Height, m_DC, 0, 0, vbSrcInvert
End Sub

Public Sub DeleteTP()
    DeleteDC m_DC
    DeleteDC m_BDC
    DeleteObject m_BMP
End Sub

Public Property Let x(x As Long)
    TPX = x
End Property

Public Property Let y(y As Long)
    TPY = y
End Property

Public Property Get x() As Long
    x = TPX
End Property

Public Property Get y() As Long
    y = TPY
End Property

Public Property Get Width() As Long
    Width = m_Width
End Property

Public Property Get Height() As Long
    Height = m_Height
End Property
